/*  muzikQ - Curses based audio player
 *
 *  Copyright (C) 2008 Tim A. Brown
 * 
 *  This file is part of muzikQ.

    muzikQ is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    muzikQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with muzikQ.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "muzikQ.h"
#include <SDL/SDL.h>
#include <stdio.h>

void Stop_CD()
    {
        if (SDL_CDStop(cdrom))
            {
                printf("Failed to stop cdrom: %s\n", SDL_GetError());
                exit(1);
            }
    }

void Pause_CD()
    {
        if (SDL_CDPause(cdrom))
            {
                printf("Failed to pause cdrom: %s\n", SDL_GetError());
                exit(1);
            }
    }

void Resume_CD()
    {
        if (SDL_CDResume(cdrom))
            {
                printf("Failed to stop cdrom: %s\n", SDL_GetError());
                exit(1);
            }
    }

void Play_Track(int track)
    {
        if (CD_INDRIVE(SDL_CDStatus(cdrom)))
            SDL_CDPlayTracks(cdrom, track, 0, 1, 0);
    }

int Num_CDRoms()
    {
        int cd_rom_drives = 0;
        cd_rom_drives = SDL_CDNumDrives();
        if (!cd_rom_drives)
            {
                printf("Failed to get number of cdroms: %s\n", SDL_GetError());
                exit(1);
            }
        return(cd_rom_drives);
    }
CDstatus CD_Status()
    {
        CDstatus cds;
        cds = SDL_CDStatus(cdrom);
        switch (cds)
            {
                case CD_TRAYEMPTY:
                    printf("cdrom tray is empty!\n");
                    exit(1);
                    break;
                case CD_STOPPED:
                    break;
                case CD_PLAYING:
                    break;
                case CD_PAUSED:
                    break;
                case CD_ERROR:
                    printf("cdrom Error!\n");
                    exit(1);
                    break;
            }
        return(cds);
    }

int CD_Add_Playlist(int songs)
    {
        int i = 0, m = 0, s = 0, f = 0;
        char tmpstr[31], istr[2];
        if (CD_INDRIVE(SDL_CDStatus(cdrom)))
        {
            
        for (i=0; i < cdrom->numtracks; ++i) 
            {
                if (cdrom->track[i].type == SDL_AUDIO_TRACK)
                    {
                        FRAMES_TO_MSF(cdrom->track[i].length, &m, &s, &f);
                        if ( f > 0 )
                            ++s;
                        play[songs].format = 3;
                        play[songs].seconds = s + (m * 60);
                        strcpy(play[songs].mfile, "CDAudioTrack");
                        strcpy(play[songs].type, "CD Audio Track");
                        strcpy(tmpstr, "CD Track ");
                        strcpy(istr, itoa(i+1));
                        strcat(tmpstr, istr);
                        strcpy(play[songs].title, tmpstr);
                        strcpy(play[songs].artist, "CDROM");
                        play[songs].bitrate = 192;
                        play[songs].sample = 44100;
                        play[songs].vol = defaultvol;
                        play[songs].track = cdrom->track[i].id;
                        play[songs].rate = 5;
                        songs++;
                    }  
            }
        return(songs);
        }
    }

/*SDL_CD *cdrom;
CDstatus status;
char *status_str;
int i;
int m, s, f;*/

 /* //Open CD-ROM drive
  cdrom = SDL_CDOpen(0);
    if ( cdrom == NULL ) {
        fprintf(stderr, "Couldn't open default CD-ROM drive: %s\n",
                        SDL_GetError());
        exit(2);
    }
    

  //check available cdroms
  cd_rom_drives = SDL_CDNumDrives();
  printf("Drives available: %d\n", SDL_CDNumDrives());
  
  //check cdrom status
  status = SDL_CDStatus(cdrom);
    switch (status) {
        case CD_TRAYEMPTY:
            status_str = "tray empty";
            break;
        case CD_STOPPED:
            status_str = "stopped";
            break;
        case CD_PLAYING:
            status_str = "playing";
            break;
        case CD_PAUSED:
            status_str = "paused";
            break;
        case CD_ERROR:
            status_str = "error state";
            break;
    }
    printf("Drive status: %s\n", status_str);
    if ( status >= CD_PLAYING ) {
        int m, s, f;
        FRAMES_TO_MSF(cdrom->cur_frame, &m, &s, &f);
        printf("Currently playing track %d, %d:%2.2d\n",
        cdrom->track[cdrom->cur_track].id, m, s);
    }
    
  //print tracks on cdrom
  printf("Drive tracks: %d\n", cdrom->numtracks);
    for ( i=0; i<cdrom->numtracks; ++i ) {
        FRAMES_TO_MSF(cdrom->track[i].length, &m, &s, &f);
        if ( f > 0 )
            ++s;
        printf("\tTrack (index %d) %d: %d:%2.2d\n", i,
        cdrom->track[i].id, m, s);
    } */
  
  // Play first track:
        /*if ( CD_INDRIVE(SDL_CDStatus(cdrom)) ) {
            //SDL_CDPlayTracks(cdrom, cdrom->numtracks-1, 0, 0, 0);
            SDL_CDPlayTracks(cdrom, 0, 0, 0, 0);
        }
  printf("Drive status: %s\n", status_str);*/