/*
    muzikQ - curses based audio player
 *
 *  Copyright (C) 2008 Tim A. Brown

    This file is part of muzikQ.

    muzikQ is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    muzikQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with muzikQ.  If not, see <http://www.gnu.org/licenses/>.
   
*/

#include "muzikQ.h"
#include <curses.h>
#include <string.h>
#include <math.h>
#include <sys/stat.h>
#include <taglib/tag_c.h>

/* FIXME: recode the load_playlist function from scratch. The current one is no good */
void load_playlist (char *argv)
{
  FILE *infile;
  char line[256];
  char *tmp, *tmpstr;
  char filename[256];
  short found = 0;
  int i = 0, v = 0;

  playlist_changes = 0;

  strcpy ((char *) &filename, argv);
   if (!strcasecmp
	((char *) &filename[strlen ((char *) &filename) - 4], ".m3u"))
    {
      if (!(infile = fopen (filename, "r+")))
	{
	  //cannot open file
          printf ("Can't open file for reading\n");
	  perror ("fopen");
	  end_program ();
	}
      while (fgets (line, 255, infile))
	{
	  line[strlen (line) - 1] = '\0';
          if (!strcasecmp (&line[strlen (line) - 4], ".mp3"))
	    {
	      for (i = found = 0; i < num_songs; i++)
		if (!strcmp (play[i].file, line))
		  found = 1;
	      if (!found)
		{
                  play[num_songs].format = 1; //added to inform file format
		  strcpy (play[num_songs].file, line);
		  if ((tmp = strtok (line, "/")) != NULL) // remove the path to the mp3 file */
		    {
		      while ((tmp = strtok ((char *) NULL, "/")) != NULL)
			strcpy (play[num_songs].mfile, tmp);
		    }
		  if (!strlen (play[num_songs].mfile))
		    strcpy (play[num_songs].mfile, play[num_songs].file);

		  play[num_songs].mfile[COLS - 15] = '\0';
                  v = getTags(num_songs);
                  strcpy(play[num_songs].type, "MPEG-1 Layer 3");
		  play[num_songs].rate = 5;
		  num_songs++;
		}
	    }
	}
      fclose (infile);
    }

  else
    if (!strcasecmp
	((char *) &filename[strlen ((char *) &filename) - 4], ".mkq"))
    {
      if (!(infile = fopen (filename, "r+")))
	{
	  printf ("Can't open file for reading\n");
	  perror ("fopen");
	  end_program ();
	}
      while (fgets (line, 255, infile))
	{
	  line[strlen (line) - 1] = '\0';
	  play[num_songs].vol = atoi (&line[strlen (line) - 3]);
	  line[strlen (line) - 4] = '\0';
	  play[num_songs].rate = atoi (&line[strlen (line) - 1]);
	  line[strlen (line) - 2] = '\0';
	  if (!strcasecmp (&line[strlen (line) - 4], ".mp3"))
	    {
	      for (i = found = 0; i < num_songs; i++)
		if (!strcmp (play[i].file, line))
		  found = 1;
	      if (!found)
		{
                  play[num_songs].format = 1;
		  strcpy (play[num_songs].file, line);
		  if ((tmp = strtok (line, "/")) != NULL)	/* remove the path to the mp3 file */
		    {
		      while ((tmp = strtok ((char *) NULL, "/")) != NULL)
			strcpy (play[num_songs].mfile, tmp);
		    }
		  if (!strlen (play[num_songs].mfile))
		    strcpy (play[num_songs].mfile, play[num_songs].file);
		  play[num_songs].mfile[COLS - 15] = '\0';
                  v = getTags(num_songs);
                  strcpy(play[num_songs].type, "MPEG-1 Layer 3");
		  num_songs++;
		}
	    }
           if (!strcasecmp (&line[strlen (line) - 4], ".ogg"))
	    {
	      for (i = found = 0; i < num_songs; i++)
		if (!strcmp (play[i].file, line))
		  found = 1;
	      if (!found)
		{
                  play[num_songs].format = 2;
		  strcpy (play[num_songs].file, line);
		  if ((tmp = strtok (line, "/")) != NULL)	/* remove the path to the mp3 file */
		    {
		      while ((tmp = strtok ((char *) NULL, "/")) != NULL)
			strcpy (play[num_songs].mfile, tmp);
		    }
                  if (!strlen (play[num_songs].mfile))
		    strcpy (play[num_songs].mfile, play[num_songs].file);
		  play[num_songs].mfile[COLS - 15] = '\0';                 
                  v = getTags(num_songs);
                  play[num_songs].rate = 5;
                  strcpy(play[num_songs].type, "Vorbis OGG");
                  num_songs++;
                }
            }
	}
      fclose (infile);
    }

  else
    if (!strcasecmp
	((char *) &filename[strlen ((char *) &filename) - 4], ".mp3"))
    {
      for (i = found = 0; i < num_songs; i++)
	if (!strcmp (play[i].file, filename))
	  found = 1;
      if (!found)
	{
	  play[num_songs].format = 1;  //added to inform file format
          strcpy (play[num_songs].file, filename);
	  if ((tmp = strtok (filename, "/")) != NULL)	/* remove the path to the mp3 file */
	    {
	      while ((tmp = strtok ((char *) NULL, "/")) != NULL)
		strcpy (play[num_songs].mfile, tmp);
	    }
	  if (!strlen (play[num_songs].mfile))
	    strcpy (play[num_songs].mfile, play[num_songs].file);

	  play[num_songs].mfile[COLS - 15] = '\0';
          v = getTags(num_songs);
          strcpy(play[num_songs].type, "MPEG-1 Layer 3");
	  play[num_songs].rate = 5;
	  num_songs++;
	}
    }
  else
    if (!strcasecmp
	((char *) &filename[strlen ((char *) &filename) - 4], ".ogg"))
    {
        //new for .ogg format!
              for (i = found = 0; i < num_songs; i++)
		if (!strcmp (play[i].file, filename))
		  found = 1;
	      if (!found)
		{
                  play[num_songs].format = 2;  //added to inform file format
                  strcpy (play[num_songs].file, filename);
                  if ((tmp = strtok (line, "/")) != NULL)	/* remove the path to the mp3 file */
		    {
		      while ((tmp = strtok ((char *) NULL, "/")) != NULL)
			strcpy (play[num_songs].mfile, tmp);
		    }
		  if (!strlen (play[num_songs].mfile))
		    strcpy (play[num_songs].mfile, play[num_songs].file);

		  play[num_songs].mfile[COLS - 15] = '\0';                 
                  v = getTags(num_songs);
                  play[num_songs].rate = 5;
                  strcpy(play[num_songs].type, "Vorbis OGG");
		  num_songs++;
                }
          //end .ogg
    } 

  else
    if (!strncasecmp
	((char *) &filename, (char *) "http://", (size_t) strlen ("http://")))
    {
      for (i = found = 0; i < num_songs; i++)
	if (!strcmp (play[i].file, filename))
	  found = 1;
      if (!found)
	{
	  strcpy (play[num_songs].file, filename);
	  strcpy (play[num_songs].mfile, filename);
	  play[num_songs].mfile[COLS - 15] = '\0';
	  play[num_songs].rate = 5;
	  num_songs++;
	}
    }

  return;
}

int write_playlist ()
{
  FILE * mkQfile;
  int i;
  playlist_changes = 0;
  if (strlen (mkQplaylist) == 0)
    show_playlist_win ();
  
  mkQfile = fopen(mkQplaylist, "w");
  if (!mkQfile)
    {
          mvwprintw(right_win, 0,0, "Fail: Can not open file for writing: %i", errno);
	  perror ("fopen");
	  end_program ();
    }
  for (i = 0; i < num_songs; i++) 
    {
      fprintf (mkQfile, "%s %d %.3d\n", play[i].file, play[i].rate,
	       play[i].vol);
    }
  fclose (mkQfile);
  return 0;
}

int delete_song (int song)
{
  int i = 0;
  playlist_changes = 1;
  //num_songs--;
  total_time -= play[song].seconds + play[song].minutes * 60;
  total_size -= (int) play[song].size / 1024;
  for (i = song; i <= num_songs; i++)
    memmove (&play[i], &play[i + 1], sizeof (struct PlayList));
  if (selected >= num_songs)
    selected = num_songs - 1;
  if (song <= current_song)
    current_song--;
  if (current_song + 1 == song)
    return (1);
  else
    return (0);
}

void get_playlist_times (int q)
{
  int i;
  struct stat file_status;
  TagLib_File *file;
  TagLib_Tag *tag;
  const TagLib_AudioProperties *properties;
  if(stat(play[q].file, &file_status) != 0)
     perror("file stat failure.");
  play[q].size = file_status.st_size;
  if (getting_times)
     total_size = ((total_size) + (file_status.st_size / 1024));
  taglib_set_strings_unicode(FALSE);
  file = taglib_file_new(play[q].file);
  if(file != NULL)
     {
         tag = taglib_file_tag(file);
         properties = taglib_file_audioproperties(file);
         play[q].seconds = taglib_audioproperties_length(properties);
         if (getting_times)
              total_time = total_time + play[q].seconds;
     }
  getting_times = 0;
}

void generate_random_playlist ()
{
  int m;
  int n;

  num_randoms = 0;
  if (random_method == 1)
    for (m = 0; m < num_songs; m++)
      for (n = 1; n <= play[m].rate; n++)
	{
	  random_playlist[num_randoms] = m;
	  num_randoms++;
	}
  else if (random_method == 2 || getting_times)
    for (m = 0; m < num_songs; m++)
      for (n = 1; n <= pow (play[m].rate, 2); n++)
	{
	  random_playlist[num_randoms] = m;
	  num_randoms++;
	}
  else if (random_method == 3)
    for (m = 0; m < num_songs; m++)
      for (n = 1;
	   n <=
	   floor (pow (play[m].rate, 2) /
		  (play[m].seconds / 60) ); n++)
	{
	  random_playlist[num_randoms] = m;
	  num_randoms++;
	}
}
